# -*- coding: utf-8 -*-
"""
Created on Tue Mar 15 17:32:36 2016

@author: Alexander
"""

import numpy as np
'''
#==============================================================================
# Define the weight updating rule            
#==============================================================================
'''
# ARB-gamma
def ARB(y, F, gamma):
    temp = np.exp(y*F)
    output = temp/((1.0+temp)**(gamma+1))
    output[np.isnan(output)] = 0.0
    output[np.isinf(output)] = 0.0
    if sum(output) == 0:
        return np.zeros(len(y)) + 1.0/len(y)
    else:
        return output/sum(output)
        
# truncated_exp        
def truncExp(y, F, gamma):
    t = -2.0
    output = np.exp(-y*F)
    output[y*F < t] = 0.0
    output[np.isinf(output)] = 0.0
    if sum(output) == 0:
        return np.zeros(len(y)) + 1.0/len(y)
    else:
        return output/sum(output)      # normalized weights on samples